#include "demo.h"

BYTE TxBuffer[] = "RAYON_IOP_WIN32_TEST_DEMO"  ; 
BYTE buf[256] ;
//---------------------------------------------------------------------------
//  int PASCAL WinMain( HANDLE hInstance, HANDLE hPrevInstance,
//                      LPSTR lpszCmdLine, int nCmdShow )
//
//  Description:
//     This is the main window loop!
//
//  Parameters:
//     As documented for all WinMain() functions.
//
//---------------------------------------------------------------------------

int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszCmdLine, int nCmdShow )
{
   MSG   msg ;
   int    i;

   if (!hPrevInstance)
      if (!InitApplication( hInstance ))
         return ( FALSE ) ;

   if (NULL == (hDEMOWnd = InitInstance( hInstance, nCmdShow )))
      return ( FALSE ) ;
   
   while( GetMessage( &msg, NULL, 0, 0 ) )
   {
      TranslateMessage( (LPMSG)&msg );
      DispatchMessage(  (LPMSG)&msg );
   }

   
   return ( (int) msg.wParam ) ;

} // end of WinMain()

//---------------------------------------------------------------------------
//  BOOL NEAR InitApplication( HANDLE hInstance )
//
//  Description:
//     First time initialization stuff.  This registers information
//     such as window classes.
//
//  Parameters:
//     HANDLE hInstance
//        Handle to this instance of the application.
//
//---------------------------------------------------------------------------

BOOL NEAR InitApplication( HANDLE hInstance )
{
   WNDCLASS  wndclass ;

   // register demo window class

   wndclass.style =         0 ;
   wndclass.lpfnWndProc =   DEMOWndProc ;
   wndclass.cbClsExtra =    0 ;
   wndclass.cbWndExtra =    DEMOEXTRABYTES ;
   wndclass.hInstance =     hInstance ;
   wndclass.hIcon =         LoadIcon( hInstance ,"DEMO");
   wndclass.hCursor =       LoadCursor( NULL, IDC_ARROW ) ;
   wndclass.hbrBackground = (HBRUSH) ( COLOR_WINDOW + 1 ) ;
   wndclass.lpszMenuName =  MAKEINTRESOURCE( DEMOMENU ) ;
   wndclass.lpszClassName = gszDEMOClass ;

   return( RegisterClass( &wndclass ) ) ;

} // end of InitApplication()

//---------------------------------------------------------------------------
//  HWND NEAR InitInstance( HANDLE hInstance, int nCmdShow )
//
//  Description:
//     Initializes instance specific information.
//
//  Parameters:
//     HANDLE hInstance
//        Handle to instance
//
//     int nCmdShow
//        How do we show the window?
//
//---------------------------------------------------------------------------

HWND NEAR InitInstance( HANDLE hInstance, int nCmdShow )
{
   HWND  hDEMOWnd ;

   // load accelerators
   ghAccel = LoadAccelerators( hInstance, MAKEINTRESOURCE( DEMOACCEL ) ) ;

   // create the DEMO window
   hDEMOWnd = CreateWindow( gszDEMOClass, gszAppName,
                           WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           685, 300,
                           NULL, NULL, hInstance, NULL ) ;

   if (NULL == hDEMOWnd)
      return ( NULL ) ;

   ShowWindow( hDEMOWnd, nCmdShow ) ;
   UpdateWindow( hDEMOWnd ) ;

   return ( hDEMOWnd ) ;

} // end of InitInstance()

//---------------------------------------------------------------------------
//  LRESULT APIENTRY DEMOWndProc( HWND hWnd, UINT uMsg,
//                                 WPARAM wParam, LPARAM lParam )
//
//  Description:
//     This is the DEMO Window Proc.  This handles ALL messages
//     to the demo window.
//
//  Parameters:
//     As documented for Window procedures.
//
//---------------------------------------------------------------------------

LRESULT APIENTRY DEMOWndProc( HWND hWnd, UINT uMsg,
                               WPARAM wParam, LONG lParam )
{
   NPDEMOINFO  npDEMOInfo ;
   PAINTSTRUCT  ps ;
   char err[15] ;
   HDC hDC ;
   int ID_TIMER ;
   
   npDEMOInfo = GETNPDEMOINFO( hWnd ) ;
   
   switch (uMsg)
   {

      case WM_CREATE:
         ID_TIMER = SetTimer( hWnd, 1, 1, NULL ) ;
         return ( CreateDEMOInfo( hWnd ) ) ;

      case WM_COMMAND:
      {
         switch ( LOWORD( wParam ) )
         {
            
            case IDM_CONNECT:
               if ( !OpenConnection( hWnd ))
               {
                  wsprintf( err, "NO FIND COM%d", port ) ;
                  MessageBox( NULL, err, "DEMO ERROR", MB_OK ) ;  
               }
               break ;
               
            case IDM_DISCONNECT:
               CloseConnection( hWnd ) ;
               break ;   
            
            case IDM_SETTINGS:
            {
               NPDEMOINFO  npDEMOInfo ;

               if (NULL == (npDEMOInfo = GETNPDEMOINFO( hWnd )))
                  return ( FALSE ) ;
               GoModalDialogBoxParam( GETHINST( hWnd ),
                                      MAKEINTRESOURCE( SETTINGSDLGBOX ), hWnd,
                                      (DLGPROC) SettingsDlgProc,
                                      (LPARAM) (LPSTR) npDEMOInfo ) ;
               
               hDC = GetDC( hWnd ) ;
               ShowForm( hWnd, hDC ) ;
               ReleaseDC( hWnd, hDC ) ;
               
               if (CONNECTED( npDEMOInfo ))
               {
                  for( port=PORT( npDEMOInfo ); 
                           port < COMPORT( npDEMOInfo )+1; port++ )
                  {
                     if ((SetupConnection( hWnd ) == 0) & (STATUS[port] == 0))
                     {
                        MessageBox( hWnd, "Settings failed!", gszAppName,
                                 MB_ICONEXCLAMATION ) ;
                        break ;
                     }
                  }               
               }
            } 
            break;  
           
            case IDM_EXIT:
               PostMessage( hWnd, WM_CLOSE, 0, 0L ) ;
               break ;
         }
      }
      break ;

      case WM_TIMER:
         KillTimer(hWnd,ID_TIMER);
         SendCommBlock( hWnd, npDEMOInfo ) ;
         ID_TIMER = SetTimer( hWnd, 1, 1, NULL ) ;
         
         break ;
         
      case WM_PAINT:
         hDC = BeginPaint( hWnd, &ps ) ;
         ShowForm( hWnd, hDC ) ;
         EndPaint( hWnd, &ps ) ;
         break ;

      case WM_DESTROY:
         KillTimer( hWnd, ID_TIMER ) ;
         DestroyDEMOInfo( hWnd ) ;
         PostQuitMessage( 0 ) ;
         break ;

      case WM_CLOSE:
         if (IDOK != MessageBox( hWnd, "OK to close window?", "DEMO Sample",
                                 MB_ICONQUESTION | MB_OKCANCEL ))
            break ;

      default:
         return( DefWindowProc( hWnd, uMsg, wParam, lParam ) ) ;
   }
   return 0L ;

} // end of DEMOWndProc()

//---------------------------------------------------------------------------
//  LRESULT NEAR CreateDEMOInfo( HWND hWnd )
//
//  Description:
//     Creates the demo information structure and sets
//     menu option availability.  Returns -1 if unsuccessful.
//
//  Parameters:
//     HWND  hWnd
//        Handle to main window.
//
//---------------------------------------------------------------------------

LRESULT NEAR CreateDEMOInfo( HWND hWnd )
{

   HMENU hMenu ;
   NPDEMOINFO   npDEMOInfo ;

   if (NULL == (npDEMOInfo =
                   (NPDEMOINFO) LocalAlloc( LPTR, sizeof( DEMOINFO ) )))
      return ( (LRESULT) -1 ) ;

   // initialize DEMO info structure
   CONNECTED( npDEMOInfo )     = FALSE ;
   COMPORT( npDEMOInfo )       = 10 ;
   PORT( npDEMOInfo )          = 3 ;
   WATCHPORT( npDEMOInfo )     = 1 ;
   BAUDRATE( npDEMOInfo )      = CBR_115200 ;
   BYTESIZE( npDEMOInfo )      = 8 ;
   FLOWCTRL( npDEMOInfo )      = FC_XONXOFF ;
   PARITY( npDEMOInfo )        = NOPARITY ;
   STOPBITS( npDEMOInfo )      = ONESTOPBIT ;
   COUNT( npDEMOInfo )         = TRUE ;
   DYNAMIC( npDEMOInfo )       = FALSE ;
   STATIC( npDEMOInfo )        = FALSE ; 
   TERMWND( npDEMOInfo ) =       hWnd ;

   // set DEMOInfo handle before any further message processing.

   SETNPDEMOINFO( hWnd, npDEMOInfo ) ;
   
   hMenu = GetMenu( hWnd ) ;
   EnableMenuItem( hMenu, IDM_DISCONNECT,
                   MF_GRAYED | MF_DISABLED | MF_BYCOMMAND ) ;
   EnableMenuItem( hMenu, IDM_CONNECT, MF_ENABLED | MF_BYCOMMAND ) ;

   return ( (LRESULT) TRUE ) ;

} // end of CreateDEMOInfo()

//---------------------------------------------------------------------------
//  BOOL NEAR DestroyDEMOInfo( HWND hWnd )
//
//  Description:
//     Destroys block associated with DEMO window handle.
//
//  Parameters:
//     HWND hWnd
//        handle to DEMO window
//
//---------------------------------------------------------------------------

BOOL NEAR DestroyDEMOInfo( HWND hWnd )
{
   NPDEMOINFO npDEMOInfo ;

   if (NULL == (npDEMOInfo = GETNPDEMOINFO( hWnd )))
      return ( FALSE ) ;

   // clean up event objects

   CloseConnection( hWnd ) ;
   
   LocalFree( npDEMOInfo ) ;
   return ( TRUE ) ;

} // end of DestroyDEMOInfo()

//---------------------------------------------------------------------------
//  BOOL NEAR OpenConnection( HWND hWnd )
//
//  Description:
//     Opens communication port specified in the DEMOINFO struct.
//     It also sets the CommState and notifies the window via
//     the fConnected flag in the DEMOINFO struct.
//
//  Parameters:
//     HWND hWnd
//        handle to DEMO window
//
//---------------------------------------------------------------------------

BOOL NEAR OpenConnection( HWND hWnd )
{
   NPDEMOINFO  npDEMOInfo ;
   HMENU hMenu ;
   BOOL fRet ;
   HDC hDC ;
   
   if (NULL == (npDEMOInfo = GETNPDEMOINFO( hWnd )))
         return ( FALSE ) ;
   
   for( port=PORT( npDEMOInfo ); port < COMPORT( npDEMOInfo )+1; port++ )
   {
      ErrCount[port] = 0;
      OutLength[port] = 0 ;
      InLength[port] = 0 ;
      OutLen[port] = 0 ;
      InLen[port] = 0 ;
      dtime[port] = 0 ;
      
   // open COMM device

      if ((STATUS[port] = IOP_Open( port, B115200|CS8|CREAD|HUPCL|CLOCAL )) != 0)
      {
         if (port == PORT( npDEMOInfo ))
            COMPORT( npDEMOInfo ) = PORT( npDEMOInfo ) ;
         else
         {
            COMPORT( npDEMOInfo ) = port-1 ;
            hMenu = GetMenu( hWnd ) ;
            EnableMenuItem( hMenu, IDM_DISCONNECT,
                          MF_ENABLED | MF_BYCOMMAND ) ;
            EnableMenuItem( hMenu, IDM_CONNECT,
                          MF_GRAYED | MF_DISABLED | MF_BYCOMMAND ) ;
         }                  
         return ( FALSE ) ;
      }
      else
      {
         IOP_ResetDIQ( port ) ;
         IOP_ResetDOQ( port ) ;
         
         fRet = SetupConnection( hWnd ) ;
         if ( fRet )
            CONNECTED( npDEMOInfo ) = TRUE ;
         else
         {
            CONNECTED( npDEMOInfo ) = FALSE ;
            return ( FALSE ) ;
         }   
      }
   }
   
   StartTime = time(NULL) ;
   
   hDC = GetDC( hWnd ) ;
   ShowForm( hWnd, hDC ) ;
   ReleaseDC( hWnd, hDC ) ; 
   
   hMenu = GetMenu( hWnd ) ;
   EnableMenuItem( hMenu, IDM_DISCONNECT,
                 MF_ENABLED | MF_BYCOMMAND ) ;
   EnableMenuItem( hMenu, IDM_CONNECT,
                 MF_GRAYED | MF_DISABLED | MF_BYCOMMAND ) ;

   return ( fRet ) ;

} // end of OpenConnection()

//---------------------------------------------------------------------------
//  BOOL NEAR SetupConnection( HWND hWnd )
//
//  Description:
//     Set up the communication port status in the DEMOINFO struct.      
//
//  Parameters:
//     HWND hWnd
//        handle to DEMO window
//
//---------------------------------------------------------------------------

BOOL NEAR SetupConnection( HWND hWnd )
{
   NPDEMOINFO  npDEMOInfo ;
   int i,bBaud,bPar,bStop,bData ; 

   if (NULL == (npDEMOInfo = GETNPDEMOINFO( hWnd )))
      return ( FALSE ) ;
   
   for( i=0; i<15; i++ )
   {
      if ( BAUDRATE( npDEMOInfo ) == BaudGroup[i] )
      {
         bBaud = i ;
         break ;
      }
   } 
   for( i=0; i<4; i++ )
   {
      if ( BYTESIZE( npDEMOInfo ) == ByteSizeGroup[i] )
      {
         bData = i << 4 ;
         break ;
      }
   }               
   for( i=0; i<2; i++ )
   {
      if ( STOPBITS( npDEMOInfo ) == StopBitsGroup[i] )
      {
         bStop = i << 6 ;
         break ;
      }
   }                        
   for( i=0; i<5; i++ )
   {
      if ( PARITY( npDEMOInfo ) == ParityGroup[i] )
      {
         bPar = i << 8  ;
         break ;
      }
   }               
   
   if (IOP_Ioctrl( port, HUPCL | CREAD | CLOCAL | 
                           bBaud | bPar | bData | bStop ) != 0)    
      return (FALSE) ;

   if (IOP_Flowctrl( port, FLOWCTRL( npDEMOInfo ) ) != 0)
      return (FALSE) ;   

   return (TRUE) ;

} // end of SetupConnection()

//---------------------------------------------------------------------------
//  BOOL NEAR CloseConnection( HWND hWnd )
//
//  Description:
//     Closes the connection to the port.  Resets the connect flag
//     in the DEMOINFO struct.
//
//  Parameters:
//     HWND hWnd
//        handle to DEMO window
//
//---------------------------------------------------------------------------

BOOL NEAR CloseConnection( HWND hWnd )
{
   NPDEMOINFO  npDEMOInfo ;
   HMENU hMenu ;
   int curport ;
   
   if (NULL == (npDEMOInfo = GETNPDEMOINFO( hWnd )))
         return ( FALSE ) ;
   
   CONNECTED( npDEMOInfo ) = FALSE ;      
   
   for( curport=PORT( npDEMOInfo ); curport < COMPORT( npDEMOInfo )+1; curport++ )
   {
      IOP_Close( curport ) ;
   }
   
   hMenu = GetMenu( hWnd ) ;
   EnableMenuItem( hMenu, IDM_DISCONNECT,
                   MF_GRAYED | MF_DISABLED | MF_BYCOMMAND ) ;
   EnableMenuItem( hMenu, IDM_CONNECT,
                   MF_ENABLED | MF_BYCOMMAND ) ;

   return ( TRUE ) ;

} // end of CloseConnection()

//---------------------------------------------------------------------------
//  VOID SendCommBlock( HWND hWnd, NPDEMOINFO npDEMOInfo )
//
//  Description:
//     Writes a block of data to the COM port and read a block of data
//     from the COM port.
//
//  Parameters:
//     HWND hWnd
//        handle to DEMO window
//
//     NPDEMOINFO npDEMOInfo
//
//---------------------------------------------------------------------------

VOID SendCommBlock( HWND hWnd, NPDEMOINFO npDEMOInfo  )    
{
   
   HFILE PORT[MAXPORT] ;
   DWORD nReadLen,nWriteLen ;

   BYTE RxBuffer[MAXBLOCK+1];

   HDC  hDC ;
   int  cmp,boxx,boxy,len,i ;
   int  ID_TIME ;
   
   hDC = GetDC( hWnd ) ;
   memset( buf, 0x0, 256 ) ;
   ID_TIME =( BAUDRATE( npDEMOInfo )/1000/lstrlen( TxBuffer ))+1 ;
      
   if (CONNECTED( npDEMOInfo ))
   {
      for( i=0; i<ID_TIME; i++ )
      {
         for( port=PORT(npDEMOInfo); port < COMPORT( npDEMOInfo )+1; port++ )
         { 
         
            EndTime[port] = time(NULL) ;
            stime[port] = EndTime[port] - StartTime ;
            sectime[port] = stime[port] - dtime[port] ;
         
            boxx = ( port-WATCHPORT( npDEMOInfo ) ) % 4 ;             
            boxy = ( port-WATCHPORT( npDEMOInfo ) ) / 4 ;
                      
            if (STATUS[port])
               continue ;
            
            nWriteLen = IOP_Write( port, TxBuffer, lstrlen( TxBuffer ) ) ;
            
            OutLength[port] += nWriteLen ;
            OutLen[port] += nWriteLen ;
            
            memset( RxBuffer, 0x0, MAXBLOCK ) ;
            len = LOWORD( IOP_DIQ_Count(port) ) ;
            if ( len > lstrlen( TxBuffer ) )
            {
               nReadLen = IOP_Read( port, RxBuffer, lstrlen( TxBuffer ) ) ;                                       
                                                         
               InLength[port] += nReadLen ; 
               InLen[port] += nReadLen ;
            }
            
            if ((port >= WATCHPORT( npDEMOInfo ))
                    && (port < WATCHPORT( npDEMOInfo )+8)) 
            { 
               if (COUNT( npDEMOInfo ))
               {
                  wsprintf( buf, "%08d", OutLength[port] ) ;              
                  TextOut( hDC, 85+boxx*165, 50+boxy*110, 
                               buf, lstrlen( buf ));       
               
                  wsprintf( buf, "%08d", InLength[port] ) ;                          
                  TextOut( hDC, 85+boxx*165, 30+boxy*110, 
                              buf, lstrlen( buf ));                                  
               }
               
               if (STATIC( npDEMOInfo ))
               {
                  if (sectime[port] > 0) 
                  {

                     Out[port] = OutLength[port] / stime[port] ;
                     wsprintf( buf, "%08d", Out[port] ) ;              
                     TextOut( hDC, 85+boxx*165, 50+boxy*110, 
                                  buf, lstrlen( buf ));       

                     In[port] = InLength[port] / stime[port] ;
                     wsprintf( buf, "%08d", In[port] ) ;                          
                     TextOut( hDC, 85+boxx*165, 30+boxy*110, 
                                 buf, lstrlen( buf ));                               
                  }
               }
                  
               if (DYNAMIC( npDEMOInfo ))
               {
                  if (sectime[port] > 0)            
                  {
                  
                     Out[port] = OutLen[port] / sectime[port] ;
                     wsprintf( buf, "%08d", Out[port] ) ;              
                     TextOut( hDC, 85+boxx*165, 50+boxy*110, 
                               buf, lstrlen( buf ));       
                  
                     In[port] = InLen[port] / sectime[port] ;
                     wsprintf( buf, "%08d", In[port] ) ;                          
                     TextOut( hDC, 85+boxx*165, 30+boxy*110, 
                                    buf, lstrlen( buf ));                               
                  }
               }        

               if (sectime[port] > 0)
                  OutLen[port] = 0 ;


               if (sectime[port] > 0)               
                  InLen[port] = 0;                         
            } 
               
            
            if (lstrlen(RxBuffer) != 0)
            {
               cmp = strcmp( TxBuffer, RxBuffer ) ;
               if (cmp != 0)
               {
               /*
               	  ErrCount[port] ++;
                  wsprintf( buf, "%d",ErrCount[port] ) ;
                  if ((port >= WATCHPORT( npDEMOInfo ))
                        && (port < WATCHPORT( npDEMOInfo )+8)) 
                     TextOut( hDC, 55+boxx*165, 78+boxy*110, 
                                      buf, lstrlen( buf ));
                                      
                  IOP_ResetDOQ(port);                    
                  IOP_ResetDIQ(port);
		*/
	    	 // ORGIN ERROR PROC
                 // wsprintf( buf, "port%d.err", port ) ;
                 // PORT[port] = _lcreat( buf, 0 ) ;
                 // _lwrite( PORT[port], RxBuffer, lstrlen( RxBuffer )) ;
                 // _lclose( PORT[port] ) ;              
                 // IOP_Close(port) ;
                 // STATUS[port] = 1 ;
                 // break ;
                 
               } 
               
            }
            
            dtime[port] = stime[port];
         }
      }  
   }
   ReleaseDC( hWnd, hDC ) ;

} // end of SendCommBlock()

//---------------------------------------------------------------------------
//  VOID NEAR FillComboBox( HINSTANCE hInstance, HWND hCtrlWnd, int nIDString,
//                          WORD NEAR *npTable, WORD wTableLen,
//                          WORD wCurrentSetting )
//
//  Description:
//     Fills the given combo box with strings from the resource
//     table starting at nIDString.  Associated items are
//     added from given table.  The combo box is notified of
//     the current setting.
//
//  Parameters:
//     HINSTANCE hInstance
//        handle to application instance
//
//     HWND hCtrlWnd
//        handle to combo box control
//
//     int nIDString
//        first resource string id
//
//     DWORD NEAR *npTable
//        near point to table of associated values
//
//     WORD wTableLen
//        length of table
//
//     DWORD dwCurrentSetting
//        current setting (for combo box selection)
//
//---------------------------------------------------------------------------

VOID NEAR FillComboBox( HINSTANCE hInstance, HWND hCtrlWnd, int nIDString,
                        DWORD NEAR *npTable, WORD wTableLen,
                        DWORD dwCurrentSetting )
{
   char  szBuffer[ MAXLEN_TEMPSTR ] ;
   WORD  wCount, wPosition ;

   for (wCount = 0; wCount < wTableLen; wCount++)
   {
      // load the string from the string resources and
      // add it to the combo box

      LoadString( hInstance, nIDString + wCount, szBuffer, sizeof( szBuffer ) ) ;
      wPosition = LOWORD( SendMessage( hCtrlWnd, CB_ADDSTRING, 0,
                                       (LPARAM) (LPSTR) szBuffer ) ) ;

      // use item data to store the actual table value

      SendMessage( hCtrlWnd, CB_SETITEMDATA, (WPARAM) wPosition,
                   (LPARAM) *(npTable + wCount) ) ;

      // if this is our current setting, select it

      if (*(npTable + wCount) == dwCurrentSetting)
         SendMessage( hCtrlWnd, CB_SETCURSEL, (WPARAM) wPosition, 0L ) ;
   }

} // end of FillComboBox()

//---------------------------------------------------------------------------
//  BOOL NEAR SettingsDlgInit( HWND hDlg )
//
//  Description:
//     Puts current settings into dialog box (via CheckRadioButton() etc.)
//
//  Parameters:
//     HWND hDlg
//        handle to dialog box
//
//  Win-32 Porting Issues:
//     - Constants require DWORD arrays for baud rate table, etc.
//     - There is no "MAXCOM" function in Win-32.  Number of COM ports
//       is assumed to be 4.
//
//---------------------------------------------------------------------------

BOOL NEAR SettingsDlgInit( HWND hDlg )
{
   char       szBuffer[ MAXLEN_TEMPSTR ] ;
   NPDEMOINFO  npDEMOInfo ;
   WORD       wCount, wPosition ;

   if (NULL == (npDEMOInfo = (NPDEMOINFO) GET_PROP( hDlg, ATOM_DEMOINFO )))
      return ( FALSE ) ;

   // fill port combo box and make initial selection
   
   wsprintf( szBuffer, "%d", PORT( npDEMOInfo ) ) ;
   SendMessage( GetDlgItem( hDlg, IDD_SPORTCB ), 
                            WM_SETTEXT, 0, (LPARAM) szBuffer ) ;

   // disable COM port combo box if connection has already been
   // established (e.g. OpenComm() already successful)

   EnableWindow( GetDlgItem( hDlg, IDD_SPORTCB ), !CONNECTED( npDEMOInfo ) ) ;

   // fill open port number combo box and make initial selection

   wsprintf( szBuffer, "%d", COMPORT( npDEMOInfo ) ) ;
   SendMessage( GetDlgItem( hDlg, IDD_EPORTCB ), 
                            WM_SETTEXT, 0, (LPARAM) szBuffer ) ;

   // disable open port number if connection has already been
   // established (e.g. OpenComm() already successful)

   EnableWindow( GetDlgItem( hDlg, IDD_EPORTCB ), !CONNECTED( npDEMOInfo ) ) ;
   
   // fill watch port number combo box and make initial selection
   
   wsprintf( szBuffer, "%d", WATCHPORT( npDEMOInfo ) ) ;
   SendMessage( GetDlgItem( hDlg, IDD_WATCHPORTCB ), 
                            WM_SETTEXT, 0, (LPARAM) szBuffer ) ;

   // fill baud combo box and make initial selection

   FillComboBox( GETHINST( hDlg ), GetDlgItem( hDlg, IDD_BAUDCB ),
                 IDS_BAUD110, BaudTable,
                 sizeof( BaudTable ) / sizeof( BaudTable[ 0 ] ),
                 BAUDRATE( npDEMOInfo ) ) ;

   // fill data bits combo box and make initial selection

   for (wCount = 5; wCount < 9; wCount++)
   {
      wsprintf( szBuffer, "%d", wCount ) ;
      wPosition = LOWORD( SendDlgItemMessage( hDlg, IDD_DATABITSCB,
                                              CB_ADDSTRING, 0,
                                              (LPARAM) (LPSTR) szBuffer ) ) ;

      // if current selection, tell the combo box

      if (wCount == BYTESIZE( npDEMOInfo ))
         SendDlgItemMessage( hDlg, IDD_DATABITSCB, CB_SETCURSEL,
                             (WPARAM) wPosition, 0L ) ;
   }

   // fill parity combo box and make initial selection

   FillComboBox( GETHINST( hDlg ), GetDlgItem( hDlg, IDD_PARITYCB ),
                 IDS_PARITYNONE, ParityTable,
                 sizeof( ParityTable ) / sizeof( ParityTable[ 0 ] ),
                 PARITY( npDEMOInfo ) ) ;

   // fill stop bits combo box and make initial selection

   FillComboBox( GETHINST( hDlg ), GetDlgItem( hDlg, IDD_STOPBITSCB ),
                 IDS_ONESTOPBIT, StopBitsTable,
                 sizeof( StopBitsTable ) / sizeof ( StopBitsTable[ 0 ] ),
                 STOPBITS( npDEMOInfo ) ) ;

   // initalize the flow control settings

   CheckDlgButton( hDlg, IDD_DTRDSR,
                   (FLOWCTRL( npDEMOInfo ) & FC_DTRDSR) > 0 ) ;
   CheckDlgButton( hDlg, IDD_RTSCTS,
                   (FLOWCTRL( npDEMOInfo ) & FC_RTSCTS) > 0 ) ;
   CheckDlgButton( hDlg, IDD_XONXOFF,
                   (FLOWCTRL( npDEMOInfo ) & FC_XONXOFF) > 0 ) ;
   
   CheckDlgButton( hDlg, IDD_COUNT, COUNT( npDEMOInfo ) > 0 ) ;
   CheckDlgButton( hDlg, IDD_DYNAMIC, DYNAMIC( npDEMOInfo ) > 0 ) ;
   CheckDlgButton( hDlg, IDD_STATIC, STATIC( npDEMOInfo ) > 0 ) ;                

   return ( TRUE ) ;

} // end of SettingsDlgInit()

//---------------------------------------------------------------------------
//  BOOL NEAR SettingsDlgTerm( HWND hDlg )
//
//  Description:
//     Puts dialog contents into DEMO info structure.
//
//  Parameters:
//     HWND hDlg
//        handle to settings dialog
//
//  Win-32 Porting Issues:
//     - Baud rate requires DWORD values.
//
//---------------------------------------------------------------------------

BOOL NEAR SettingsDlgTerm( HWND hDlg )
{
   NPDEMOINFO  npDEMOInfo ;
   WORD       wSelection ;
   BOOL       b ;
   TCHAR      szBuffer[MAX_PATH];

   if (NULL == (npDEMOInfo = (NPDEMOINFO) GET_PROP( hDlg, ATOM_DEMOINFO )))
      return ( FALSE ) ;

   // get port selection

   GetDlgItemText( hDlg, IDD_SPORTCB, szBuffer, sizeof( szBuffer ) ) ;
   PORT( npDEMOInfo ) =
         MyAtol( szBuffer, &b ) ;  
   
   // get open port number selection
   
   GetDlgItemText( hDlg, IDD_EPORTCB, szBuffer, sizeof( szBuffer ) ) ;
   COMPORT( npDEMOInfo ) =
         MyAtol( szBuffer, &b ) ; 
   
   // get watch port number selection
   
   GetDlgItemText( hDlg, IDD_WATCHPORTCB, szBuffer, sizeof( szBuffer ) ) ;

   WATCHPORT( npDEMOInfo ) =
         MyAtol( szBuffer, &b ) ; 

   // get baud rate selection

   wSelection =
      LOWORD( SendDlgItemMessage( hDlg, IDD_BAUDCB, CB_GETCURSEL,
                                  0, 0L ) ) ;
   BAUDRATE( npDEMOInfo ) =
      SendDlgItemMessage( hDlg, IDD_BAUDCB, CB_GETITEMDATA,
                          (WPARAM) wSelection, 0L ) ;

   // get data bits selection

   BYTESIZE( npDEMOInfo ) =
      LOBYTE( LOWORD( SendDlgItemMessage( hDlg, IDD_DATABITSCB,
                                          CB_GETCURSEL,
                                          0, 0L ) ) + 5 ) ;

   // get parity selection

   wSelection =
      LOWORD( SendDlgItemMessage( hDlg, IDD_PARITYCB, CB_GETCURSEL,
                                  0, 0L ) ) ;
   PARITY( npDEMOInfo ) =
      LOBYTE( LOWORD( SendDlgItemMessage( hDlg, IDD_PARITYCB,
                                          CB_GETITEMDATA,
                                          (WPARAM) wSelection,
                                          0L ) ) ) ;

   // get stop bits selection

   wSelection =
      LOWORD( SendDlgItemMessage( hDlg, IDD_STOPBITSCB, CB_GETCURSEL,
                                  0, 0L ) ) ;
   STOPBITS( npDEMOInfo ) =
      LOBYTE( LOWORD( SendDlgItemMessage( hDlg, IDD_STOPBITSCB,
                                          CB_GETITEMDATA,
                                          (WPARAM) wSelection, 0L ) ) ) ;

   // get flow control settings

   FLOWCTRL( npDEMOInfo ) = 0 ;
   if (IsDlgButtonChecked( hDlg, IDD_DTRDSR ))
      FLOWCTRL( npDEMOInfo ) |= FC_DTRDSR ;
   if (IsDlgButtonChecked( hDlg, IDD_RTSCTS ))
      FLOWCTRL( npDEMOInfo ) |= FC_RTSCTS ;
   if (IsDlgButtonChecked( hDlg, IDD_XONXOFF ))
      FLOWCTRL( npDEMOInfo ) |= FC_XONXOFF ;
   
   COUNT( npDEMOInfo ) = 0 ;
   if (IsDlgButtonChecked( hDlg, IDD_COUNT ))
      COUNT( npDEMOInfo ) = !COUNT( npDEMOInfo ) ;
   DYNAMIC( npDEMOInfo ) = 0 ;
   if (IsDlgButtonChecked( hDlg, IDD_DYNAMIC ))
      DYNAMIC( npDEMOInfo ) = !DYNAMIC( npDEMOInfo ) ;
   STATIC( npDEMOInfo ) = 0 ;   
   if (IsDlgButtonChecked( hDlg, IDD_STATIC ))
      STATIC( npDEMOInfo ) = !STATIC( npDEMOInfo ) ;
      
   return ( TRUE ) ;

} // end of SettingsDlgTerm()

//---------------------------------------------------------------------------
//  BOOL FAR PASCAL SettingsDlgProc( HWND hDlg, UINT uMsg,
//                                   WPARAM wParam, LPARAM lParam )
//
//  Description:
//     This handles all of the user preference settings for
//     the DEMO.
//
//  Parameters:
//     same as all dialog procedures
//
//  Win-32 Porting Issues:
//     - npDEMOInfo is a DWORD in Win-32.
//
//---------------------------------------------------------------------------

BOOL FAR PASCAL SettingsDlgProc( HWND hDlg, UINT uMsg,
                                 WPARAM wParam, LPARAM lParam )
{
   switch (uMsg)
   {
      case WM_INITDIALOG:
      {
         NPDEMOINFO  npDEMOInfo ;

         // get & save pointer to DEMO info structure

         npDEMOInfo = (NPDEMOINFO) lParam ;

         SET_PROP( hDlg, ATOM_DEMOINFO, (HANDLE) npDEMOInfo ) ;

         return ( SettingsDlgInit( hDlg ) ) ;
      }

      case WM_COMMAND:
         switch ( LOWORD( wParam ))
         {

            case IDD_OK:
               // Copy stuff into structure
               SettingsDlgTerm( hDlg ) ;
               EndDialog( hDlg, TRUE ) ;
               return ( TRUE ) ;

            case IDD_CANCEL:
               // Just end
               EndDialog( hDlg, TRUE ) ;
               return ( TRUE ) ;
         }
         break;

      case WM_DESTROY:
         REMOVE_PROP( hDlg, ATOM_DEMOINFO ) ;
         break ;
   }
   return ( FALSE ) ;

} // end of SettingsDlgProc()

//---------------------------------------------------------------------------
//  VOID NEAR GoModalDialogBoxParam( HINSTANCE hInstance,
//                                   LPCSTR lpszTemplate, HWND hWnd,
//                                   DLGPROC lpDlgProc, LPARAM lParam )
//
//  Description:
//     It is a simple utility function that simply performs the
//     MPI and invokes the dialog box with a DWORD paramter.
//
//  Parameters:
//     similar to that of DialogBoxParam() with the exception
//     that the lpDlgProc is not a procedure instance
//
//---------------------------------------------------------------------------

VOID NEAR GoModalDialogBoxParam( HINSTANCE hInstance, LPCSTR lpszTemplate,
                                 HWND hWnd, DLGPROC lpDlgProc, LPARAM lParam )
{
   DLGPROC  lpProcInstance ;

   lpProcInstance = (DLGPROC) MakeProcInstance( (FARPROC) lpDlgProc,
                                                hInstance ) ;
   DialogBoxParam( hInstance, lpszTemplate, hWnd, lpProcInstance, lParam ) ;
   FreeProcInstance( (FARPROC) lpProcInstance ) ;

} // end of GoModalDialogBoxParam()

//---------------------------------------------------------------------------      
//  VOID ShowForm( HWND hWnd, HDC hDC )
//
//  Description:
//     Paints the rectangle Box by the paint struct of the DC.
//
//  Parameters:
//     HWND hWnd
//        handle to DEMO window
//
//     HDC hDC
//        paint struct of the DC.
//
//---------------------------------------------------------------------------

void ShowForm( HWND hWnd, HDC hDC)
{
    NPDEMOINFO npDEMOInfo ;        
    HBRUSH hbrush,holdbrush ;
    char   Port2[80],buf[256] ;
    int    curport,nport,comport ;
        
    npDEMOInfo = GETNPDEMOINFO( hWnd ) ;
    
    for(nport=WATCHPORT( npDEMOInfo ); 
                 nport<WATCHPORT( npDEMOInfo )+8; nport++)
    {
       comport = (nport-WATCHPORT( npDEMOInfo ) ) %4 ;             
       curport = (nport-WATCHPORT( npDEMOInfo ) ) /4 ;
       wsprintf(Port2,"                               ") ;                          
       TextOut(hDC, 60+comport*165, 8+curport*110,Port2,lstrlen(Port2)) ;
       wsprintf(Port2,"COM%d",nport) ;                          
       TextOut(hDC, 60+comport*165, 8+curport*110,Port2,lstrlen(Port2)) ;
    }   
      
    hbrush = CreateSolidBrush(RGB(255,255,255)) ;
    holdbrush = SelectObject(hDC,hbrush) ;
    for(nport=0; nport<4; nport++)
    {
       RoundRect(hDC,10+nport*165,25,170+nport*165,100,10,10) ;
       RoundRect(hDC,10+nport*165,75,170+nport*165,100,10,10) ;
    }
    SelectObject(hDC,holdbrush) ;
    DeleteObject(hbrush) ;
	
    hbrush = CreateSolidBrush(RGB(255,255,255)) ;
    holdbrush = SelectObject(hDC,hbrush) ;
    for(nport=0; nport<4; nport++)
    {
       RoundRect(hDC,10+nport*165,135,170+nport*165,210,10,10) ;
       RoundRect(hDC,10+nport*165,185,170+nport*165,210,10,10) ;
    }     
    SelectObject(hDC,holdbrush) ;
    DeleteObject(hbrush) ;
    
    for(nport=0; nport<8; nport++)                 
    {
       comport = nport % 4 ;
       if ( nport < 4 )
          curport = 0 ;
       else
          curport =110 ;
       memset( buf, 0x0, 256 ) ;
       wsprintf(buf,"00000000") ;   
       TextOut( hDC, 85+comport*165, 30+curport, buf, lstrlen( buf ));
       wsprintf(buf,"00000000") ;
       TextOut( hDC, 85+comport*165, 50+curport, buf, lstrlen( buf ));          
       wsprintf(Port2,"Input   :") ;
       TextOut(hDC, 15+comport*165, 30+curport,Port2,lstrlen(Port2)) ;
       wsprintf(Port2,"Output :") ;
       TextOut(hDC, 15+comport*165, 50+curport,Port2,lstrlen(Port2)) ;
    }
	
} // end of ShowForm()

//---------------------------------------------------------------------------      
//  Function: MyAtol(LPTSTR szString, LPBOOL bSuccess)
//
//  Description:
//     This function will convert an ascii string to a LONG.
//
//  Ptarameters:
//     LPTSTR szString
//        the string on the setting window 
//       
//     LPBOOL bSuccess 
//        check each char is ascii char or not  
//
//---------------------------------------------------------------------------      

LONG MyAtol(LPTSTR szString, LPBOOL bSuccess)
{
    LPTSTR p ;
    LONG l ;
    LONG lMultiplier ;
    BOOL bDigit ;

    lMultiplier = 10 ;

    p = szString ;
    l = 0 ;

    while (*p)      //while chars
    {
       bDigit = FALSE ;  //set to false for each char that we look at

       if (*p >= (TCHAR) '0' && *p <= (TCHAR) '9')  //is it an ascii char ?
       {
          bDigit = TRUE ;
          l+=(*p - (TCHAR) '0') ;
       }

       if (bDigit == FALSE)
       {
          *bSuccess = FALSE ;
          return 0 ;
       }

       p++ ;               //get next char

       if (*p)             //if there is going to be at least one more char
          l*=lMultiplier ; //then multiply what we have by the multiplier...
    }

    *bSuccess = TRUE ;

    return l ;             //success! return the value.
}

//---------------------------------------------------------------------------
//  End of File: demo.c
//---------------------------------------------------------------------------       
