// ascii definitions
#define ASCII_XON       0x11
#define ASCII_XOFF      0x13

// ON/OFF setting
#define ON              1
#define OFF             0 

// General definition 
#define TRUE	1
#define FALSE	0
#define OK	0
#define FAIL    -1

// control modes 
#define	CBAUD	  0x000F
#define	B110	  0x0000
#define	B300	  0x0001
#define	B600      0x0002
#define	B1200     0x0003
#define	B2400	  0x0004
#define	B4800	  0x0005
#define	B9600	  0x0006
#define	B14400	  0x0007
#define	B19200	  0x0008
#define	B38400	  0x0009
#define	B56000	  0x000A
#define	B57600	  0x000B
#define	B115200	  0x000C
#define	B128000	  0x000D
#define	B256000	  0x000E
#define	CSIZE	  0x0030
#define	CS5	  0x0000
#define	CS6	  0x0010
#define	CS7	  0x0020
#define	CS8	  0x0030
#define	CSTOPB	  0x0040
#define	CREAD	  0x0080
#define CPARITYB  0x0700
#define	PARNONO	  0x0000
#define PAREVEN   0x0100
#define	PARODD	  0x0200
#define PARMARK   0x0300
#define PARSPACE  0x0400
#define	HUPCL	  0x0800
#define	CLOCAL	  0x1000

// return port status IOP_Status() definitions
#define S_OPEN		0x0040	/* Port has opened */
#define S_MODEM		0x0080	/* Is Modem line */
#define S_CTS		0x0100	/* Clear To Send is on */
#define S_RX		0x0200	/* Receiver ready */
#define S_DCD		0x0400	/* Data Carrier Detect is on */
#define S_TX		0x0800	/* Transmitter empty */
#define S_DSR		0x1000	/* Data Set Ready */

// error flag
#define E_OVERRUN       0x01
#define E_OVERFLOW      0x02
#define E_PARITY        0x04
#define E_TXFULL        0x08

// Flow control setting
#define FC_DTRDSR       0x01
#define FC_RTSCTS       0x02
#define FC_XONXOFF      0x04

DWORD    BaudGroup[] =
         {
            CBR_110, CBR_300, CBR_600, CBR_1200, CBR_2400,
            CBR_4800, CBR_9600, CBR_14400, CBR_19200, CBR_38400,
            CBR_56000, CBR_57600, CBR_115200, CBR_128000, CBR_256000
         } ;

DWORD    ParityGroup[] =
         {
            NOPARITY, EVENPARITY, ODDPARITY, MARKPARITY, SPACEPARITY
         } ;

DWORD    StopBitsGroup[] =
         {
            ONESTOPBIT, TWOSTOPBITS
         } ;
         
DWORD    ByteSizeGroup[] =
         {
            5, 6, 7, 8
         } ;            

int APIENTRY IOP_Open(int, int);        
int APIENTRY IOP_Putc(int, LPSTR);        
int APIENTRY IOP_Getc(int, LPSTR);        
DWORD APIENTRY IOP_Write(int, LPSTR, int);       
DWORD APIENTRY IOP_Read(int, LPSTR, int);        
DWORD APIENTRY IOP_DOQ_Count(int);    
DWORD APIENTRY IOP_DIQ_Count(int);   
int APIENTRY IOP_ResetDOQ(int);    
int APIENTRY IOP_ResetDIQ(int);    
int APIENTRY IOP_SetDTR(int, int);
int APIENTRY IOP_SetRTS(int, int);       
int APIENTRY IOP_Close(int);       
int APIENTRY IOP_Ioctrl(int, int);   
int APIENTRY IOP_Flowctrl(int, int);
int APIENTRY IOP_GetIoctrl(int);
int APIENTRY IOP_GetFlowctrl(int);
int APIENTRY IOP_Status(int);      
int APIENTRY IOP_DataStatus(int);

//---------------------------------------------------------------------------
//  End of File: tty.h
//---------------------------------------------------------------------------